// RCS-ID: $Id: Composer.cpp,v 1.2 2006/02/23 19:18:28 cecilios Exp $
//--------------------------------------------------------------------------------------
//    LenMus Phonascus: The teacher of music
//    Copyright (c) 2002-2006 Cecilio Salmeron
//
//    This program is free software; you can redistribute it and/or modify it under the 
//    terms of the GNU General Public License as published by the Free Software Foundation;
//    either version 2 of the License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
//    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
//    PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along with this 
//    program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, 
//    Fifth Floor, Boston, MA  02110-1301, USA.
//
//    For any comment, suggestion or feature request, please contact the manager of 
//    the project at cecilios@users.sourceforge.net
//
//-------------------------------------------------------------------------------------
/*! @file Composer.cpp
    @brief Implementation file for class lmComposer
    @ingroup auxmusic
*/
/*! @class lmComposer 
    @ingroup score_kernel
    @brief An algorithm to synthesize a score.

    lmComposer is an abstract class to implement different algorithms to synthesize
    a music score.
    To isolate the algorithm so that I can easily change it and experiment
    I encapsulate algoritms in objects, all of them a specialization of the generic
    class lmComposer
*/

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
#pragma implementation "Composer.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "Composer.h"

lmComposer::lmComposer()
{
    //
}